﻿function IG_OnLoad()
		IG_VERSION = "Version " ..GetAddOnMetadata("IGuard", "Version");

		SlashCmdList["IGuardCOMMAND"] = IGuardSlashHandler;
		  SLASH_IGuardCOMMAND1 = "/IGuard";
		SlashCmdList["IGuardRaidCOMMAND"] = IGuardRaidSlashHandler;
		  SLASH_IGuardRaidCOMMAND1 = "/IGuardRaid";
		  SLASH_IGuardRaidCOMMAND2 = "/IGR";
		SlashCmdList["IGuardSoloCOMMAND"] = IGuardSoloSlashHandler;
		  SLASH_IGuardSoloCOMMAND1 = "/IGuardSolo";
		  SLASH_IGuardSoloCOMMAND2 = "/IGS";
		SlashCmdList["IGuardPartyCOMMAND"] = IGuardPartySlashHandler;
		  SLASH_IGuardPartyCOMMAND1 = "/IGuardParty";
		  SLASH_IGuardPartyCOMMAND2 = "/IGP";

end
function IG_OnEvent()
	if ( event == "PLAYER_LOGIN" ) then
		IG_ChatMessage("IGuard "..IG_VERSION.." loaded. Type |c00FFFFFF/IGuard|r to display options.");
		IG_ChatMessage("Remember to set up your Key Bindings.");

-- Fooling around :)
--	IGuardDB = {["RAID"] = "RAID",
--				["PARTY"] = "PARTY",
--				["SAY"] = "YELL",
--				["HEnabled"] = true,
--				["Enabled"] = true	}

	
		if (IG_RAIDCHANNEL == nil) then
			IG_RAIDCHANNEL = "RAID";
			IGuardFrameCheckButton18:SetChecked(1) --Checks Raid in Raidmode
			IG_PARTYCHANNEL = "PARTY";
			IGuardFrameCheckButton11:SetChecked(1) --Checks Party in Party Mode
			IG_SAYCHANNEL = "YELL";
			IGuardFrameCheckButton5:SetChecked(1) --Check Yell in Solomode
		end
		
		if (IGuardEnabled == nil) then
			IGuardEnabled = true;
			IGuardFrameCheckButton1:SetChecked(1) -- Check Enabled
			IGHelpEnabled = true;
			IGuardFrameCheckButton3:SetChecked(1) -- Check Help if Possible
			IG_RW_ENABLE = true;
			IGuardFrameCheckButton2:SetChecked(1) -- Check Raid Warning
		end
		
		if (IG_Enemy == nil) then
			IG_Enemy = IGuardRecheck();
		end
	end
	-- big settings check
	if IGuardEnable == true then
		IGuardFrameCheckButton1:SetChecked(1); -- Check Enabled
	end
	if IGHelpEnabled == true then
		IGuardFrameCheckButton3:SetChecked(1); -- Check Help if Possible
	end
	if	IG_RW_ENABLE == true then
		IGuardFrameCheckButton2:SetChecked(1);
	end
	
	if (UnitFactionGroup("player") == "Horde") then
		IG_Language = "Orcish";
		IG_Enemy = "Alliance";
	elseif (UnitFactionGroup("player") == "Alliance") then
		IG_Language = "Common";
		IG_Enemy = "Horde";
	else
		IG_Language = nil;
		IG_Enemy = "Enemy";
	end

end

function IGHelpText()
	if (IGHelpEnabled == true) then
		return ", Help if possible.";
	else
		return ".";
	end
end
function IG_Afflicted() 
local v = 1
	if not (UnitDebuff("player",v) == nil) then
		while (UnitDebuff("player",v)) do
			local i = UnitDebuff("player", v);
			if not (IG_DB_TRAPPMENT[i] == nil) then
				local k = IG_DB_TRAPPMENT[i];
				return k;
			end
			v=v+1;
		end
		return "debuff error";
	else 
		return "No Debuff";
	end
end  
function IGuardRecheck()
	if (UnitFactionGroup("player") == "Horde") then
		IG_Language = "Orcish";
		IG_Enemy = "Alliance";
	elseif (UnitFactionGroup("player") == "Alliance") then
		IG_Language = "Common";
		IG_Enemy = "Horde";
	else
		IG_Language = nil;
		IG_Enemy = "Enemy";
	end
 return IG_Enemy;	
end 
function IG_ChatMessage(msg)
 --local sends out instructions and messages
	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage("- IGuard: "..msg ,0.8, 0.8, 0.3);
	end
end
function IG_ChannelType(msg,arg1)
--Sets the diffirent channels parsed from /slashcommand
	if (msg == "RAID") then
		IG_RAIDCHANNEL = arg1;
	elseif (msg == "PARTY") then
		IG_PARTYCHANNEL = arg1;
	elseif (msg == "SAY") then
		IG_SAYCHANNEL = arg1;
	elseif (msg == "DEFAULT") then
		IG_UI_Reset();
		IG_RAIDCHANNEL = "RAID";
		IGuardFrameCheckButton18:SetChecked(1) --Checks Raid in Raidmode
		IG_PARTYCHANNEL = "PARTY";
		IGuardFrameCheckButton11:SetChecked(1) --Checks Party in Party Mode
		IG_SAYCHANNEL = "YELL";
		IGuardFrameCheckButton5:SetChecked(1) --Check Yell in Solomode
		IG_ChatMessage("Channels reseted")
	else
	IG_ChatMessage("Error: Failed to change Channel type.")
	end
end
function IG_UI_Reset()
 local i = 4;
	while ( i < 22) do	
	 getglobal("IGuardFrameCheckButton"..i):SetChecked(nil);
	 i = i + 1
	end
end 
function IG_Bindings(msg)
IG_DB_Report = {	[1] = "One "..IG_Enemy.." at "..GetMinimapZoneText()..""..IGHelpText().."",
					[2] = "Two "..IG_Enemy.." at "..GetMinimapZoneText()..""..IGHelpText().."",
					[3] = "Three "..IG_Enemy.." at "..GetMinimapZoneText()..""..IGHelpText().."",
					[4] = "Four "..IG_Enemy.." at "..GetMinimapZoneText()..""..IGHelpText().."",
					[5] = IG_Enemy.." ZERG at "..GetMinimapZoneText()..""..IGHelpText().."",
					[6] = GetMinimapZoneText().." is safe, "..IG_Enemy.." is dead.",
					[7] = "Im "..IG_Afflicted()..", "..GetMinimapZoneText().." IS NOT SAFE.",
					[8] = "Test"..IG_Afflicted().."" }
	if ( GetNumPartyMembers() == 0) then
		--Checks if the player isin't in a group
		if ( IG_CHANNEL == IG_PARTYCHANNEL or  IG_CHANNEL == IG_RAIDCHANNEL )then
		IG_ChatMessage("|c00FFFFFFReport Channel adjusted to:|r Solo Mode");
		IG_CHANNEL = IG_SAYCHANNEL;
		else
		IG_CHANNEL = IG_SAYCHANNEL;
		end
	elseif ( GetNumPartyMembers() >= 0 and UnitInRaid("player") == nil) then
		--Checks if the player is in a Party
		if (  IG_CHANNEL == IG_SAYCHANNEL or  IG_CHANNEL == IG_RAIDCHANNEL ) then
		IG_ChatMessage(" |c00FFFFFFReport Channel adjusted to:|r Group Mode");
		IG_CHANNEL = IG_PARTYCHANNEL;
		else
		IG_CHANNEL = IG_PARTYCHANNEL;
		end
	elseif (GetNumPartyMembers() >= 0 and UnitInRaid("player") == 1) then
		--Checks if the player is in a Raidgroup
		if (  IG_CHANNEL == IG_PARTYCHANNEL or  IG_CHANNEL == IG_SAYCHANNEL  ) then
		IG_ChatMessage(" |c00FFFFFFReport Channel adjusted to:|r Raid Mode");
		IG_CHANNEL = IG_RAIDCHANNEL;
		else
		IG_CHANNEL = IG_RAIDCHANNEL;
		end
	end
	-- a quick interveene for those that disable IGuard
	if (IGuardEnabled == false) then
		msg = "disable";
	end
	if (msg == "disable") then
		IG_ChatMessage("Currently Disabled.")
	else
		IG_Reporter(IG_DB_Report[msg]);
	end
end
function IG_Raid_Level()
--returns: 2 for leader, 1 for assistant/promoted, 0 for reguar raid member
	if ( IsRaidLeader() == 1 ) then
	 return 2;
	elseif ( IsOfficer() == 1 ) then 
	 return 1;
	else 
	 return 0;
	end
end
function IG_Battleground()
--returns 1 if inside a battleground, 0 elseway
 IG_BG_DB = {	["Alterac Valley"] = true,
				["Arathi Basin"] = true,
				["Warsong Gulch"] = true }
	if ( IG_BG_DB[GetRealZoneText()] == true ) then
	 return 1;
	else 
	 return 0;
	end
end
function IG_Reporter(msg)
	if (IG_CHANNEL == "GENERAL" or IG_CHANNEL == "LOCALDEFENSE") then
		--makes sure that it sends to the right channel if one changes zone/area
		local mapZone = GetRealZoneText();
		local index = GetChannelName(IG_CHANNEL.." - "..mapZone);
		if (not index ~= nil) then
		SendChatMessage("IGuard: " .. msg,"CHANNEL",IG_Language,index); 
		end
	elseif ( IG_RW_ENABLE == true and IG_CHANNEL == "RAID") then
		--makes sure that the player can use Raid warning when activated
		if ( IG_Raid_Level() >= 1 ) then
			SendChatMessage("IGuard: ".. msg,"RAID_WARNING");
		else
			IG_ChatMessage("You must be Promoted or Leader for Blizzard /RW to work.");
			IG_ChatMessage("RW Support Disabled, use /IGuard Warning to enable again");
			SendChatMessage("IGuard: ".. msg,IG_CHANNEL);
			IG_RW_ENABLE = false;
		end
	elseif ( IG_Battleground() == 1 and IG_CHANNEL == "RAID") then
		SendChatMessage("IGuard: " .. msg,"BATTLEGROUND")
	else
		SendChatMessage("IGuard: " .. msg,IG_CHANNEL)
	end
end
function IGuardRaidSlashHandler(msg)
	if IG_RAID_CHANNEL_TYPE[string.upper(msg)] then
		IG_ChatMessage("Raid-Group Channel Set to "..msg);
		IG_ChannelType("RAID",string.upper(msg));
	else
		local text = "Valid Channals are:\n";
		local text = text .. "- IGuard: LocalDefense, General, Raid, Party, Guild\n";
		IG_ChatMessage(text);
	end 
end
function IGuardPartySlashHandler(msg)
	if IG_PARTY_CHANNEL_TYPE[string.upper(msg)] then
		IG_ChatMessage("Group Channel Set to "..msg);
		IG_ChannelType("PARTY",string.upper(msg));
	else
		local text = "Valid Channals are:\n";
		local text = text .. "- IGuard: LocalDefense, General, Party, Guild\n";
		IG_ChatMessage(text);
	end 
end
function IGuardSoloSlashHandler(msg)
	if IG_SOLO_CHANNEL_TYPE[string.upper(msg)] then
		IG_ChatMessage("Solo Channel Set to "..msg);
		IG_ChannelType("SAY",string.upper(msg));
	else
		local text = "Valid Channals are:\n";
		local text = text .. "- IGuard: LocalDefense, General, Say, Yell, Guild\n";
		IG_ChatMessage(text);
	end 
end

function IGuardSlashHandler(msg)
	if (msg == nil) then 
		IGuardStatus();
		IGuardFrame:Show();
	elseif string.lower(msg) == "enable" then
		ToggleIGuard(1);
	elseif string.lower(msg) == "disable" then
		ToggleIGuard(0);
	elseif string.lower(msg) == "helpme" then
		if (IGHelpEnabled == false) then 
			IG_HelpMe(1);
		else
			IG_HelpMe(0);
		end
	elseif string.lower(msg) == "warning" then
		IG_RAID_WARNING();
	elseif string.lower(msg) == "status" then
		IGuardStatusReport();
	elseif string.lower(msg) == "recheck" then
		IGuardRecheck();
	elseif string.lower(msg) == "reset" then
		IG_ChannelType("DEFAULT");
	--elseif string.lower(msg) == "options" then
	--	IGuardFrame:Show()
	else
		IGuardStatus();
		IGuardFrame:Show();
	end
end 
function IGuardStatusReport()
	local text = "Language set to: |c00FFFFFF" .. IG_Language .. "|r\n";
--	text = text .. "- IGuard: |c00FFFFFFCurrent Enemy:|r " .. IGuardRecheck() .. "\n";
	if (IGuardEnabled == true) then
		IGStatus = "- IGuard: |c00FFFFFFCurrent Status:|r Enabled.\n";
	else
		IGStatus = "- IGuard: |c00FFFFFFCurrent Status:|r Disabled.\n";
	end
	if (IGHelpEnabled == true) then
		IGHelp = "- IGuard: |c00FFFFFFHelp if Possible Enabled.|r\n";
	else
		IGHelp = "- IGuard: |c00FFFFFFHelp if Possible Disabled.|r\n";   
	end
	if (IG_RW_ENABLE == true) then
		IGRW = "- IGuard: |c00FFFFFF/rw Reporting Enabled.|r\n";
	else
		IGRW = "- IGuard: |c00FFFFFF/rw Reporting Disabled.|r\n";   
	end
	local text = text .. IGHelp
	local text = text .. IGStatus
	local text = text .. IGRW
	local text = text .. "- IGuard: " .. IG_RAIDCHANNEL .. " In Raid Group\n";
	local text = text .. "- IGuard: " .. IG_PARTYCHANNEL .. " In Regular Groups\n";
	local text = text .. "- IGuard: " .. IG_SAYCHANNEL .. " When Allone\n";
	IG_ChatMessage(text)
end
function IGuardStatus()
	local text = "- /IGuard |c00FFFFFFTo open this dialog.|r\n";
	local text = text .. "- /IGuard enable/disable |c00FFFFFFTo enable or disable IGuard Reports.|r\n";
	local text = text .. "- /IGuard helpme |c00FFFFFFTo disable/enable 'Help if Possible' in report.|r\n";
	local text = text .. "- /IGuard status |c00FFFFFFTo show current settings.|r\n";
	local text = text .. "- /IGuard recheck|c00FFFFFF if you Language is wrong use this command.|r\n";
	local text = text .. "- /IGuard reset |c00FFFFFFTo to reset channel settings.|r\n";
	local text = text .. "- /IGuard warning |c00FFFFFFTo use /RW in Raid (Need Promoted or Leader to use).|r\n"
	IG_ChatMessage(text)
end
function ToggleIGuard(msg)
	if (msg == 0) then
		if (IGuardEnabled == true) then
			IGuardEnabled = false;
			IG_ChatMessage("Disabled.");
			IGuardFrameCheckButton1:SetChecked(nil) --Checkbutton
		else
			IG_ChatMessage("Already Disabled.");
		end
	elseif (msg == 1) then
		if (IGuardEnabled == true) then
			IG_ChatMessage("Already Enabled.");
		else
			IGuardEnabled = true;
			IG_ChatMessage("Enabled.");
			IGuardFrameCheckButton1:SetChecked(1) --Checksbutton
		end
	end
end
function IG_HelpMe(msg)
	if (msg == 0) then
		if (IGHelpEnabled == true) then
			IGHelpEnabled = false;
			IG_ChatMessage("|c00FFFFFFHelp if Possible Disabled.|r\n");
			IGuardFrameCheckButton3:SetChecked(nil) --Checkbutton
		else
			IG_ChatMessage("Help Already Disabled.");
		end
	elseif (msg == 1) then
		if (IGHelpEnabled == false) then
			IGHelpEnabled = true;
			IG_ChatMessage("|c00FFFFFFHelp if Possible Enabled.|r\n");
			IGuardFrameCheckButton3:SetChecked(1) --Chekbutton
		else
			IG_ChatMessage("Help already enabled");
		end
   
   end
end
function IG_RAID_WARNING()
		if (IG_RW_ENABLE == false) then
			IG_RW_ENABLE = true;
			IG_ChatMessage("|c00FFFFFF/rw Reporting Enabled.|r\n");
			IGuardFrameCheckButton2:SetChecked(1); -- Checkbutton
		else
			IG_RW_ENABLE = false;
			IG_ChatMessage("|c00FFFFFF/rw Reporting Disabled.|r\n");
			IGuardFrameCheckButton2:SetChecked(nil) --Checkbutton
		end
end